<?php
// CommerceML Импорт Заказов
defined('CML_INCLUDE_FOLDER') or die('Access denied');
//echo '<pre>'.print_r($obj,true).'</pre>';

// получим список статусов
$cml_finitems=array();
if (!empty($cml['scif_finitem_group'])) {
 $res=$db->sql_query('SELECT id, name FROM '.SCIF_PREFIX.'spr_finitems WHERE parent="'.$cml['scif_finitem_group'].'"');
 if ($db->sql_num_rows($res)) {
  while ($row=$db->sql_fetch_assoc($res)) {
   $cml_finitems[$row['name']]=$row['id'];
  }
 }
}

$date_insert=time();
 foreach ($obj->Документ AS $val) {
 $err='';
 $doc_id=(string)$val->Ид;

 // статус заказа
 $finitem=0;
  if (!empty($cml['scif_finitem_group'])) {
   if (!empty($val->ЗначенияРеквизитов->ЗначениеРеквизита)) {
    foreach ($val->ЗначенияРеквизитов->ЗначениеРеквизита as $fv) {
     if ((string)$fv->Наименование=='Статус заказа' and isset($cml_finitems[(string)$fv->Значение])) {
      $finitem=$cml_finitems[(string)$fv->Значение];
      break;
     }
    }
   }
  }

  // проверим, нет ли такого документа в СКИФ
  $check_doc=$db->sql_fetch_assoc($db->sql_query('SELECT id, finitem, payment, contr, summa FROM '.SCIF_PREFIX.'doc WHERE cml_id="'.$doc_id.'"'));
  if ($check_doc) { // документ уже импортирован, обновим статус
   if ($check_doc['finitem']!=$finitem) {
   $db->sql_query('UPDATE '.SCIF_PREFIX.'doc SET
   `finitem`="'.$finitem.'", user_update="'.$cml['invoice']['user_insert'].'", date_update="'.$date_insert.'"
   WHERE id="'.$check_doc['id'].'"');
   }
  // данные для внесения оплаты
  $scif_id=$check_doc['id'];
  $summa=$check_doc['summa'];
  $contr_id=$check_doc['contr'];
  $doc_date=date('Y-m-d H:i:s');

  } else { // новый заказ

   // товары в документе
   if (!empty($val->Товары->Товар)) {
    $goods=array();
    $summa=0;
    foreach ($val->Товары->Товар as $nv) {
     $cml_id=trim((string)$nv->Ид);
     $pos=strpos($cml_id, '#'); // в выгрузке опции товаров выгружаются в виде id_родителя#id_товара
     if ($pos) {
      $cml_id=substr($cml_id, ($pos+1));
     }
     $price=floatval((string)$nv->ЦенаЗаЕдиницу);
     $quant=floatval((string)$nv->Количество);
     $summa+=round($quant*$price);
     $goods[$cml_id]=array('price'=>$price, 'quant'=>$quant, 'name'=>(string)$nv->Наименование);
     // данные ниже нужны если товара в СКИФ еще нет и мы будем его создавать
     if (!empty($cml['scif_nom_group'])) {
      if (!empty($nv->Штрихкод)) {
       $goods[$cml_id]['barcode']=(string)$nv->Штрихкод;
      }
      if (!empty($nv->c)) {
       $goods[$cml_id]['vendorcode']=(string)$nv->Артикул;
      }
     }
    }
    // получим коды товаров из базы СКИФ по cml_id
    $goods=cml_goods($goods);
    // print_r($goods); echo $summa.'<br>';
    // составляем SQL для вставки в таблицу деталей документа
    $invoice_sql='';
    foreach ($goods as $gk=>$gv) {
     if (empty($gv['scif_id']) and !empty($cml['scif_nom_group'])) { // создаем новый товар
      $gv['scif_id']=cml_nom_create($gk);
     }
     if (empty($gv['scif_id'])) {
      $err.='Не найден товар ['.$gk.'] '.$gv['name'].' для импорта заказа №'.$doc_id.PHP_EOL;
     } else {
      $invoice_sql.='("###","'.$gv['scif_id'].'","'.$gv['quant'].'","'.$gv['price'].'",'.$date_insert.',"'.$cml['invoice']['user_insert'].'"),';
     }
    }
   } else {
    $err.='Нет данных о товарах в документе '.$doc_id;
   }
   if ($err) {
    $errors.=$err;
    continue;
   }
   // echo $invoice_sql;

   // данные о клиенте
   if (!empty($cml['invoice']['contr'])) { // клиента берем из настроек, а не из файла
    $contr_id=$cml['invoice']['contr'];
   } else {
    $contr=$val->Контрагенты->Контрагент;
    $cml_id=strtok((string)$contr->Ид,'#'); // может иметь вид 111#ООО "Ромашка"
    $contr_name=htmlclean((string)$contr->Наименование);
    $email=$phone='';
    $sql='name="'.$contr_name.'",
  parent="'.$cml['scif_contr_group'].'",
  fullname="'.htmlclean((string)$contr->ПолноеНаименование).'",
  address="'.htmlclean((string)(!empty($contr->Адрес->Представление)?$contr->Адрес->Представление:$contr->АдресРегистрации->Представление)).'"';
    // Email и телефон могут содержаться как в Контактах, так и в самом Контрагенте
    if (!empty($contr->Контакты->Контакт)) {
     foreach ($contr->Контакты->Контакт as $cv) {
      if (!$email and (string)$cv->Тип=='Почта') {
       $email=htmlclean((string)$cv->Значение);
      } elseif (!$phone and in_array((string)$cv->Тип, array('Телефон', 'ТелефонРабочий'))) {
       $phone=htmlclean((string)$cv->Значение);
      }
     }
    }

    if (!$email and !empty($contr->email->Представление)) {
     $email=htmlclean((string)$contr->email->Представление);
    }
    if (!$phone and !empty($contr->Телефон->Представление)) {
     $phone=htmlclean((string)$contr->Телефон->Представление);
    }

    if ($email and filter_var($email, FILTER_VALIDATE_EMAIL)) {
     $sql.=',email="'.$email.'"';
    } else {
     $email='';
    }
    if ($phone and preg_match('#\d+#', $phone)) {
     $phone=preg_replace('#[^\d+]+#', '', $phone);
     $phone=substr($phone, -(!empty($cml['phone_length'])?$cml['phone_length']:10));
     $sql.=',phone="'.$phone.'"';
    } else {
     $phone='';
    }

    // проверим, есть ли уже в СКИФ клиент с таким cml_id или name
    $contr_id=false;
    $check_contr=$db->sql_fetch_assoc($db->sql_query('SELECT id, cml_id FROM '.SCIF_PREFIX.'spr_contrs WHERE cml_id="'.$cml_id.'"'));
    if ($check_contr) { // уже есть
     $contr_id=$check_contr['id'];
    } else { // проверим по названию или email
     $check_contr=$db->sql_fetch_assoc($db->sql_query('SELECT id, cml_id FROM '.SCIF_PREFIX.'spr_contrs WHERE name="'.$contr_name.'"'
     .($email?' OR email="'.$email.'"':'')
     .($phone?' OR phone LIKE "%'.preg_replace('#(\d)#', '$1%', $phone).'"':'')));
     if ($check_contr) {
      $contr_id=$check_contr['id'];
      // внесем cml_id в базу
      $db->sql_query('UPDATE '.SCIF_PREFIX.'spr_contrs SET cml_id="'.$cml_id.'" WHERE id="'.$contr_id.'"');
     } else { // клиента в СКИФ нет, создаем
      $sql='INSERT INTO '.SCIF_PREFIX.'spr_contrs
     SET '.$sql.', user_insert="'.$cml['invoice']['user_insert'].'", date_insert="'.$date_insert.'", cml_id="'.$cml_id.'"';
      if ($db->sql_query($sql)) {
       $contr_id=$db->sql_insert_id();
      } else {
       $errors.='Не удалось создать контрагента для документа '.$cml_id.', возможно, значения полей не уникальны: '.$sql;
       continue;
      }
     }
    }
   }

   if (!$contr_id) {
    $errors.='Не удалось определить контрагента для документа '.$cml_id;
    continue;
   }
  // клиент получен, можем создавать документ
  $doc_date=trim((string)$val->Дата).' '.(!empty($val->Время)?trim((string)$val->Время):date('H:i:s'));
  $sql_doc='INSERT INTO '.SCIF_PREFIX.'doc SET
 `date_insert`='.$date_insert.',
 `doc_date`="'.$doc_date.'",
 `summa`="'.$summa.'",
 `note`="'.htmlclean((string)$val->Комментарий).'",
 `finitem`="'.$finitem.'",
 `cml_id`="'.$doc_id.'"';
   if (empty($cml['invoice']['contr'])) {
    $sql_doc.=', `contr`="'.$contr_id.'"';
   }
   foreach ($cml['invoice'] as $ik=>$iv) {
    $sql_doc.=', `'.$ik.'`="'.$iv.'"';
   }
   if ($db->sql_query($sql_doc)) {
    $scif_id=$db->sql_insert_id();
    if ($scif_id) { // добавляем товары (детали документа)
     $invoice_sql=str_replace('###', $scif_id, $invoice_sql); // подставляем номер документа
     if ($db->sql_query('INSERT INTO '.SCIF_PREFIX.'doc_det (doc_id,nom_id,quant,price,date_insert,user_insert) VALUES '.mb_substr($invoice_sql, 0, -1))) {
      if ($cml['invoice']['type']==2) { // документ Продажа, списываем остатки товаров на складе и увеличиваем задолженность клиента
       recalc_remains('after', 2, $scif_id, $cml['invoice']['store'], 0, $contr_id, $summa);
      }
      $cml_imported_docs[$doc_id]=array('id'=>$scif_id, 'summa'=>$summa);
     } else {
      $errors.='Ошибка добавления товаров в документ!'.$invoice_sql;
      continue;
     }
    } else {
     $errors.='Не удалось создать документ '.$doc_id;
     continue;
    }
   } else {
    $errors.='Не удалось создать документ! Возможно, документ с номером '.$doc_id.' уже существует! '.$sql_doc.' '.$db->sql_error();
    continue;
   }
  } // конец импорта нового заказа

  // проверим и внесем оплату
  if (empty($check_doc['payment']) or $check_doc['payment']==0) {
   $payment=false;
   $payment_method='default';
   if (!empty($cml['payment_methods'])) {
    if (!empty($val->ЗначенияРеквизитов->ЗначениеРеквизита)) {
     foreach ($val->ЗначенияРеквизитов->ЗначениеРеквизита as $fv) {
      if ((string)$fv->Наименование=='Заказ оплачен' and (string)$fv->Значение=='true') {
       $payment=true;
      } elseif ((string)$fv->Наименование=='Метод оплаты') {
       $payment_method=(string)$fv->Значение;
      }
     }
     if ($payment) { // заказ оплачен, определим кассу/счет для внесения
      if (isset($cml['payment_methods'][$payment_method])) {
       $payment_account=$cml['payment_methods'][$payment_method];
      } elseif (isset($cml['payment_methods']['default'])) {
       $payment_account=$cml['payment_methods']['default'];
      } else {
       echo 'Не найден способ оплаты '.$payment_method.'<br>';
       $default_account=key($cml['payment_methods']);
       $payment_account=$cml['payment_methods'][$default_account];
      }
      // вносим оплату
      $payment_arr=array('id'=>$scif_id, 'summa'=>$summa, 'store'=>$cml['invoice']['store'], 'contr'=>$contr_id,
      'type'=>$cml['invoice']['type'], 'finitem'=>0, 'doc_date'=>$doc_date, 'date_insert'=>$date_insert,
      'org'=>$cml['invoice']['org'], 'user_insert'=>$cml['invoice']['user_insert'], 'account'=>$payment_account);
      cml_doc_pay($payment_arr);
     }
    }
   }
  }

// echo $sql.'<pre>'.print_r($val,true).'</pre>';
 }